#!/usr/bin/env python
import os
import sys
import string
import re
import csv
import math

def Varianza(media,list_values):
	list_tmp=[]
	for value in list_values:
		list_tmp.append((value-media)*(value-media))
	if len(list_tmp)==1:
		return float(0)
	else:
		return float(sum(list_tmp))/float(len(list_tmp)-1)
	
def Media_dev_std(protection,metric,_type,target):
	list_values=[]
	_sum=0
	media=0
	varianza=0
	dev=0
	std_error=0
		
	f_csv=open(path_input+"/"+prog+"/"+prog+"_"+_type+".csv")
	reader = csv.DictReader(f_csv, delimiter=separator)
	
	if target=="all_target_for_program":
		for row in reader:
			if row['protection']==protection and int(row['flag_obf_tigress(0=made_1=not)'])==0:
				list_values.append(int(row[metric]))
		target="all"
	else:
		for row in reader:
			if row['protection']==protection and int(row['flag_obf_tigress(0=made_1=not)'])==0 and row["target_makefile"]==target :
				list_values.append(int(row[metric]))
	f_csv.close()
			
	_sum=sum(list_values)
	if(len(list_values)==0):
		media='nan'
		varianza='nan'
		dev='nan'
		std_error='nan'
	else:
		media=float(_sum) / float(len(list_values))
		varianza=Varianza(media,list_values)
		dev=math.sqrt(varianza)
		std_error=float(dev) / float(len(list_values))
			
	if _type=="frama":
		report.write(protection+",frama_c,"+target+","+metric+","+str(media)+","+str(len(list_values))+","+str(varianza)+","+str((len(list_values)-1))+","+str(dev)+","+str(std_error)+"\n")	
	else:
		report.write(protection+",diablo,"+target+","+metric+","+str(media)+","+str(len(list_values))+","+str(varianza)+","+str((len(list_values)-1))+","+str(dev)+","+str(std_error)+"\n")	
	

################################################
'''
Def header row

Diablo:
#program,protection,tool_protection,target_makefile,path_file_from_main_directory_program,function,flag_obf_tigress(0=made_1=not),nr_ins_static,nr_src_oper_static,nr_dst_oper_static,halstead_program_size_static,nr_edges_static,nr_indirect_edges_CFIM_static,cyclomatic_complexity_static + Flatten,Opaque,AntiBranchAnalysis

Frama:
#program,protection,tool_protection,target_makefile,path_file_from_main_directory_program,function,flag_obf_tigress(0=made_1=not),Sloc,Decision point,Global variables,If,Loop,Goto,Assignment,Exit point,Function,Function call,Pointer dereferencing,Cyclomatic complexity

'''
################################################

################################################
#protection and metrics

p_Diablo=['vanilla','function_flattening_10%',"branch_functions_10%","opaque_predicates_10%","function_flattening_30%","branch_functions_30%","opaque_predicates_30%","function_flattening_50%","branch_functions_50%","opaque_predicates_50%","Flatten","Opaque","AntiBranchAnalysis","EncodeArithmetic"]
m_Diablo=['nr_ins_static','nr_src_oper_static','nr_dst_oper_static','halstead_program_size_static','nr_edges_static','nr_indirect_edges_CFIM_static','cyclomatic_complexity_static']

p_Frama=['vanilla',"Flatten","Opaque","AntiBranchAnalysis","EncodeArithmetic"]
m_Frama=['Sloc','Decision point','Global variables','If','Loop','Goto','Assignment','Exit point','Function','Function call','Pointer dereferencing','Cyclomatic complexity']

################################################

################################################
#DEF separator

separator=","

################################################

#input
if len(sys.argv)==2:
	path_input=sys.argv[1].rstrip()
	path_output="./result_media_dev"
elif len(sys.argv)==3:
	path_input=sys.argv[1].rstrip()
	path_output=sys.argv[2].rstrip()+"./result_media_dev"
else:
	print "Insert path_input and/or path_output"
	exit (-1)
	
	
os.system("rm -r -f "+path_output)
os.system("mkdir "+path_output)


#frama_Diablo_all
print "\033[32;1m-----Media,Variance,Std_dev,Std_err for each program-----\033[0m\n"

for prog in os.popen("ls "+path_input).readlines():
	prog=prog.rstrip()
	os.system("mkdir -p "+path_output+"/"+prog)
	file_report=path_output+"/"+prog+"/"+prog+"_all.csv"
	
	#calculate
	report=open(file_report,"a")
	report.write("#protection,tool,target,metric,media,num_samples_m,variance,num_samples_v,std_dev,std_err\n")
	
	for protection in p_Frama:
		for metric in m_Frama:
			Media_dev_std(protection,metric,"frama","all_target_for_program")
	for protection in p_Diablo:
		for metric in m_Diablo:
			Media_dev_std(protection,metric,"diablo","all_target_for_program")
	
	report.close()		
			

#frama_Diablo_for_each_target

print "\033[32;1m-----Media,Variance,Std_dev,Std_err for each program divided by target-----\033[0m\n"

for prog in os.popen("ls "+path_input).readlines():
	prog=prog.rstrip()
	os.system("mkdir -p "+path_output+"/"+prog)
	file_report=path_output+"/"+prog+"/"+prog+"_for_each_target.csv"
	
	#find target
	f_csv=open(path_input+"/"+prog+"/"+prog+"_frama.csv")
	reader = csv.DictReader(f_csv, delimiter=separator)
	list_target=[]
	for row in reader:
		if not(row["target_makefile"] in list_target):
			list_target.append(row["target_makefile"])
	f_csv.close()
	
	f_csv=open(path_input+"/"+prog+"/"+prog+"_diablo.csv")
	reader = csv.DictReader(f_csv, delimiter=separator)
	for row in reader:
		if not(row["target_makefile"] in list_target):
			list_target.append(row["target_makefile"])
	f_csv.close()
	
	#calculate
	report=open(file_report,"a")
	report.write("#protection,tool,target,metric,media,num_samples_m,variance,num_samples_v,std_dev,std_err\n")
	
	for targ in list_target:
		for protection in p_Frama:
			for metric in m_Frama:
				Media_dev_std(protection,metric,"frama",targ)
	for targ in list_target:			
		for protection in p_Diablo:
			for metric in m_Diablo:
				Media_dev_std(protection,metric,"diablo",targ)
				
	report.close()


#frama and diablo global by all program
'''
print "\033[32;1m-----Media,Variance,Std_dev,Std_err global-----\033[0m\n"

os.system("mkdir -p "+path_output+"/on_all_programs")
file_report=path_output+"/on_all_programs/on_all_programs.csv"
report=open(file_report,"a")
report.write("#protection,tool,target,metric,media,num_samples_m,variance,num_samples_v,std_dev,std_err\n")
	

for protection in p_Frama:
	for metric in m_Frama:
		list_values=[]
		_sum=0
		media=0
		varianza=0
		dev=0
		std_error=0
		
		for prog in os.popen("ls "+path_input).readlines():
			prog=prog.rstrip()
			
			#read csv
			f_csv=open(path_input+"/"+prog+"/"+prog+"_frama.csv")
			reader = csv.DictReader(f_csv, delimiter=separator)
			
			for row in reader:
				if row['protection']==protection and int(row['flag_obf_tigress(0=made_1=not)'])==0:
					list_values.append(int(row[metric]))
			
			f_csv.close()
			
		_sum=sum(list_values)
		if(len(list_values)==0):
			media='nan'
			varianza='nan'
			dev='nan'
			std_error='nan'
		else:
			media=float(_sum) / float(len(list_values))
			varianza=Varianza(media,list_values)
			dev=math.sqrt(varianza)
			std_error=float(dev) / float(len(list_values))
		
		report.write(protection+",frama_c,"+"null"+","+metric+","+str(media)+","+str(len(list_values))+","+str(varianza)+","+str((len(list_values)-1))+","+str(dev)+","+str(std_error)+"\n")	

for protection in p_Diablo:
	for metric in m_Diablo:
		list_values=[]
		_sum=0
		media=0
		varianza=0
		dev=0
		std_error=0
		
		for prog in os.popen("ls "+path_input).readlines():
			prog=prog.rstrip()
			
			#read csv
			f_csv=open(path_input+"/"+prog+"/"+prog+"_diablo.csv")
			reader = csv.DictReader(f_csv, delimiter=separator)
			
			for row in reader:
				if row['protection']==protection and int(row['flag_obf_tigress(0=made_1=not)'])==0:
					list_values.append(int(row[metric]))
			
			f_csv.close()
			
		_sum=sum(list_values)
		if(len(list_values)==0):
			media='nan'
			varianza='nan'
			dev='nan'
			std_error='nan'
		else:
			media=float(_sum) / float(len(list_values))
			varianza=Varianza(media,list_values)
			dev=math.sqrt(varianza)
			std_error=float(dev) / float(len(list_values))
		
		report.write(protection+",diablo,"+"null"+","+metric+","+str(media)+","+str(len(list_values))+","+str(varianza)+","+str((len(list_values)-1))+","+str(dev)+","+str(std_error)+"\n")	
''' 




 
