#!/usr/bin/env python
import os
import sys
import csv
import re
import matplotlib.pyplot as plt
import collections

if len(sys.argv)==2:
	path_input=sys.argv[1].rstrip()
	path_output="./result"
elif len(sys.argv)==3:
	path_input=sys.argv[1].rstrip()
	path_output=sys.argv[2].rstrip()+"./result"
else:
	print "Insert path_input and/or path_output"
	exit (-1)

#creazione cartella output
os.system("rm -r -f "+path_output)
os.system("mkdir "+path_output)
os.system("mkdir "+path_output+"/frama")
os.system("mkdir "+path_output+"/diablo")

################################################
#DEF separator

separator=","

################################################

################################################
#protection and metrics

p_Diablo1=['function_flattening_10%','function_flattening_30%','function_flattening_50%',"branch_functions_10%","branch_functions_30%","branch_functions_50%","opaque_predicates_10%","opaque_predicates_30%","opaque_predicates_50%","Flatten","Opaque","AntiBranchAnalysis","EncodeArithmetic"]
p_Diablo=['function_flattening_10%','function_flattening_30%','function_flattening_50%',"branch_functions_10%","branch_functions_30%","branch_functions_50%","opaque_predicates_10%","opaque_predicates_30%","opaque_predicates_50%"]
m_Diablo=['nr_ins_static','nr_src_oper_static','nr_dst_oper_static','halstead_program_size_static','nr_edges_static','nr_indirect_edges_CFIM_static','cyclomatic_complexity_static']

p_Frama=["Flatten","Opaque","AntiBranchAnalysis","EncodeArithmetic"]
m_Frama=['Sloc','Decision point','Global variables','If','Loop','Goto','Assignment','Exit point','Function','Function call','Pointer dereferencing','Cyclomatic complexity']

################################################

#os.system("mkdir "+path_output)

#frama



Protection_book_Frama={
'Sloc' : {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
},
'Decision point': {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
},
'Global variables': {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
},
'If': {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
},
'Loop': {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
},
'Goto': {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
},
'Assignment': {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
},
'Exit point': {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
},
'Function': {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
},
'Function call': {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
},
'Pointer dereferencing': {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
},
'Cyclomatic complexity': {"Flatten" : [0,0],
			"Opaque" : [0,0],
			"AntiBranchAnalysis" : [0,0],
			"EncodeArithmetic" : [0,0]
}
}


Protection_book_Diablo={
'nr_ins_static' : { 'function_flattening_10%' : [0,0],
					'function_flattening_30%' : [0,0],
					'function_flattening_50%' : [0,0],
					"branch_functions_10%" : [0,0],
					"branch_functions_30%" : [0,0],
					"branch_functions_50%" : [0,0],
					"opaque_predicates_10%" : [0,0],
					"opaque_predicates_30%" : [0,0],
					"opaque_predicates_50%" : [0,0]
},
'nr_src_oper_static' : { 'function_flattening_10%' : [0,0],
					'function_flattening_30%' : [0,0],
					'function_flattening_50%' : [0,0],
					"branch_functions_10%" : [0,0],
					"branch_functions_30%" : [0,0],
					"branch_functions_50%" : [0,0],
					"opaque_predicates_10%" : [0,0],
					"opaque_predicates_30%" : [0,0],
					"opaque_predicates_50%" : [0,0]
},
'nr_dst_oper_static' : { 'function_flattening_10%' : [0,0],
					'function_flattening_30%' : [0,0],
					'function_flattening_50%' : [0,0],
					"branch_functions_10%" : [0,0],
					"branch_functions_30%" : [0,0],
					"branch_functions_50%" : [0,0],
					"opaque_predicates_10%" : [0,0],
					"opaque_predicates_30%" : [0,0],
					"opaque_predicates_50%" : [0,0]
},
'halstead_program_size_static' : { 'function_flattening_10%' : [0,0],
					'function_flattening_30%' : [0,0],
					'function_flattening_50%' : [0,0],
					"branch_functions_10%" : [0,0],
					"branch_functions_30%" : [0,0],
					"branch_functions_50%" : [0,0],
					"opaque_predicates_10%" : [0,0],
					"opaque_predicates_30%" : [0,0],
					"opaque_predicates_50%" : [0,0]
},	
'nr_edges_static' : { 'function_flattening_10%' : [0,0],
					'function_flattening_30%' : [0,0],
					'function_flattening_50%' : [0,0],
					"branch_functions_10%" : [0,0],
					"branch_functions_30%" : [0,0],
					"branch_functions_50%" : [0,0],
					"opaque_predicates_10%" : [0,0],
					"opaque_predicates_30%" : [0,0],
					"opaque_predicates_50%" : [0,0]
},
'nr_indirect_edges_CFIM_static' : { 'function_flattening_10%' : [0,0],
					'function_flattening_30%' : [0,0],
					'function_flattening_50%' : [0,0],
					"branch_functions_10%" : [0,0],
					"branch_functions_30%" : [0,0],
					"branch_functions_50%" : [0,0],
					"opaque_predicates_10%" : [0,0],
					"opaque_predicates_30%" : [0,0],
					"opaque_predicates_50%" : [0,0]
},	
'cyclomatic_complexity_static' : { 'function_flattening_10%' : [0,0],
					'function_flattening_30%' : [0,0],
					'function_flattening_50%' : [0,0],
					"branch_functions_10%" : [0,0],
					"branch_functions_30%" : [0,0],
					"branch_functions_50%" : [0,0],
					"opaque_predicates_10%" : [0,0],
					"opaque_predicates_30%" : [0,0],
					"opaque_predicates_50%" : [0,0]
},
}

lst_color=["red","green","orange","blue","purple", "pink", "black", "gray", "brown"]

trad_f={
'Sloc':"Linee di codice",
'Decision point':"Numero di punti decisionali",
'Global variables':"Numero di varibili globali",
'If':"Numero di istruzioni if",
'Loop':"Numero di cicli loop",
'Goto':"Numero di istruzioni goto",
'Assignment':"Numero di assegnazioni",
'Exit point':"Numero di exit point",
'Function':"Numero di funzioni contenute nel programma",
'Function call':"Numero di funzioni chiamate",
'Pointer dereferencing':"Numero di pointer dereferencing",
'Cyclomatic complexity':"Complessita' ciclomatica"
}


print "\033[32;1m-----Grafici Media Potency Frama----\033[0m\n"
#retrieve information
for prog in os.popen("ls "+path_input).readlines():
		prog=prog.rstrip()
		f_csv=open(path_input+"/"+prog+"/"+prog+"_media_potency_protection_frama.csv")
		reader = list(csv.DictReader(f_csv, delimiter=separator))
		for row in reader:
			if (row['media']=="nan") or (row["#protection"] not in p_Frama):
				continue
			else:
				media=float(row["media"])
				samples=int(row["num_samples_m"])
				mul= media*samples
				lst=Protection_book_Frama.get(row["metric"]).pop(row["#protection"])
				new_med=float(lst[0])+mul
				new_s=samples+int(lst[1])
				Protection_book_Frama.get(row["metric"] ).update({row["#protection"] : [new_med,new_s]})

#calcolo media potency
print_book={}
for metr in m_Frama:
	print_book.update({metr : {}})
	for prot in p_Frama:
		potency = Protection_book_Frama.get(metr).get(prot)
		if potency[1] == 0:
			potency[1] = 1
		print_book.get(metr).update({prot : float(potency[0]/potency[1])})

#grafico	

for metr in m_Frama:
	tmp=print_book.get(metr).values()
	for i in range(0,len(p_Frama)):
		plt.bar([i],print_book.get(metr).get(p_Frama[i]), color="blue")	
	#plt.legend(loc='best')
	#for j in range(0,len(p_Diablo)):
	plt.xticks([0,1,2,3],p_Frama,rotation=20,horizontalalignment='right',fontsize=6,color='black')
	plt.title(trad_f[metr])
	plt.ylabel('Media potency')
	#plt.show()
	plt.savefig(path_output+"/frama/"+metr+".eps", format='eps', dpi=1200)
	plt.clf()


print "\033[32;1m-----Grafici Media Potency Diablo----\033[0m\n"
#retrieve information
for prog in os.popen("ls "+path_input).readlines():
		prog=prog.rstrip()
		f_csv=open(path_input+"/"+prog+"/"+prog+"_media_potency_protection_diablo.csv")
		reader = list(csv.DictReader(f_csv, delimiter=separator))
		for row in reader:
			if (row['media']=="nan") or (row["#protection"] not in p_Diablo):
				continue
			else:
				media=float(row["media"])
				samples=int(row["num_samples_m"])
				mul= media*samples
				lst=Protection_book_Diablo.get(row["metric"]).pop(row["#protection"])
				new_med=float(lst[0])+mul
				new_s=samples+int(lst[1])
				Protection_book_Diablo.get(row["metric"] ).update({row["#protection"] : [new_med,new_s]})

#calcolo media potency
print_book={}
for metr in m_Diablo:
	print_book.update({metr : {}})
	for prot in p_Diablo:
		potency = Protection_book_Diablo.get(metr).get(prot)
		if potency[1] ==0:
			potency[1] = 1
		print_book.get(metr).update({prot : float(potency[0]/potency[1])})

#grafico	

trad={
'nr_ins_static' : "Numero di istruzioni assembly",
'nr_src_oper_static': "Numero di operandi sorgente",
'nr_dst_oper_static': "Numero di operandi destinazione",
'halstead_program_size_static' : "Lunghezza di Halstead",
'nr_edges_static': "Numero ramificazioni del control flow graph",
'nr_indirect_edges_CFIM_static' : "Numero di ramificazioni indirette",
'cyclomatic_complexity_static': "Complessita' ciclomatica"
}

trad_t={
"function_flattening_10%":"Control flow flattening 10%",
"function_flattening_30%":"Control flow flattening 30%",
"function_flattening_50%":"Control flow flattening 50%",
"opaque_predicates_10%":"Predicati opachi 10%",
"opaque_predicates_30%":"Predicati opachi 30%",
"opaque_predicates_50%":"Predicati opachi 50%",
"branch_functions_10%":"Anti branch analysis 10%",
"branch_functions_30%":"Anti branch analysis 30%",
"branch_functions_50%":"Anti branch analysis 50%",
}

for metr in m_Diablo:
	tmp=print_book.get(metr).values()
	i=0
	while i < len(p_Diablo):
		plt.bar([i%3],print_book.get(metr).get(p_Diablo[i]), color="blue")
		i=i+1
		plt.bar([i%3],print_book.get(metr).get(p_Diablo[i]), color="blue")
		i=i+1
		plt.bar([i%3],print_book.get(metr).get(p_Diablo[i]), color="blue")
		plt.xticks([0,1,2],[trad_t[p_Diablo[i-2]],trad_t[p_Diablo[i-1]],trad_t[p_Diablo[i]]],rotation=15,horizontalalignment='right',fontsize=6,color='black')
		plt.ylabel('Media potency')
		plt.title(trad[metr])
		plt.savefig(path_output+"/diablo/"+re.sub('_((10)|(30)|(50))%', "", p_Diablo[i])+"_"+metr+".eps", format='eps', dpi=1200)	
		plt.clf()
		i=i+1
		
	#plt.legend(loc='best')
	#for j in range(0,len(p_Diablo)):
	#plt.xticks([0,1,2,3,4,5,6,7,8],p_Diablo,rotation=20,horizontalalignment='right',fontsize=6,color='black')
	#plt.show()

